

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     Silver
#property indicator_color2     Blue
#property indicator_color3     Green
#property indicator_color4     Red
#property indicator_width1     2
#property indicator_width3     3
#property indicator_width4     3
#property indicator_level1     0
#property indicator_levelcolor Gold

//
//
//
//
//

extern int    FastEMA         = 12;
extern int    SlowEMA         = 26;
extern int    SignalSMA       = 9;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double MacdBuffer[];
double SignalBuffer[];
double GreenBuffer[];
double RedBuffer[];
double trend[];

//
//
//
//
//

int init() 
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,MacdBuffer);  SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0, "MACD");
   SetIndexBuffer(1,SignalBuffer);SetIndexStyle(1,DRAW_LINE);      SetIndexLabel(1, "Signal"); 
   SetIndexBuffer(2,GreenBuffer);
   SetIndexBuffer(3,RedBuffer);  
   SetIndexBuffer(4,trend);
   
   //
   //
   //
   //
   //
   
   IndicatorShortName("MACD Alert(" +FastEMA+ "," +SlowEMA+ "," +SignalSMA+ ")");
   return(0);  
}

//
//
//
//
//

int deinit() {   return (0);}

//
//
//
//
//

int start() {
   
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(i=0; i<limit; i++) MacdBuffer[i] = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-
                                          iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
       
   for(i=limit; i>=0; i--)
   { 
         SignalBuffer[i] = iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA, i);
         
         //
         //
         //
         //
         //
         
         if (MacdBuffer[i] > SignalBuffer[i]){
             GreenBuffer[i] = MacdBuffer[i];
             RedBuffer[i]   = EMPTY_VALUE;
           }
        else 
           {
            RedBuffer[i]   = MacdBuffer[i];
            GreenBuffer[i] = EMPTY_VALUE;
           }     
                  
                  trend[i] = trend[i+1];
         if (MacdBuffer[i] > SignalBuffer[i] && MacdBuffer[i+1] <= SignalBuffer[i+1]) trend[i] = 1;  
         if (MacdBuffer[i] < SignalBuffer[i] && MacdBuffer[i+1] >= SignalBuffer[i+1]) trend[i] = -1; 
                                    
   }
   
   if (alertsOn)
      {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}

//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," macd ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," macd  "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}


